// A0902  Zegar z formatowaniem wskazań
#include <LiquidCrystal.h>
#include <Wire.h> // biblioteka I2C
#include <RtcDS3231.h> // biblioteka dla DS3231
RtcDS3231<TwoWire> zegar(Wire); // tworzymy obiekt zegar
LiquidCrystal wysw (2, 3, 4, 5, 6, 7); //obiekt wysw

void setup ()   {   //jednorazowo:
  Serial.begin(9600);  zegar.Begin(); wysw.begin(16, 2); 
  RtcDateTime czasKompilacji = RtcDateTime(__DATE__, __TIME__);
  zegar.SetDateTime(czasKompilacji); zegar.SetIsRunning(true);}
  
void loop () { 
 RtcDateTime czasAktualny = zegar.GetDateTime();
 wysw.clear(); printDateTime(czasAktualny);  delay(200);}

//funkcja formatująca wyświetlany wynik:
#define countof(a) (sizeof(a) / sizeof(a[0]))
void printDateTime(const RtcDateTime& dt) {
 char datestring[16];snprintf_P(datestring,countof(datestring),
 PSTR("%02u/%02u %02u:%02u:%02u"), dt.Day(), dt.Month(),
 dt.Hour(),dt.Minute(),dt.Second()); wysw.print(datestring); }
